#! /bin/sh
### BEGIN INIT INFO
# Provides:          tcpdump
# Required-Start:    $remote_fs $network
# Required-Stop:     $remote_fs $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: start/stop packet capture using tcpdump
# Description:       start/stop packet capture using tcpdump
#                    
### END INIT INFO


# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="packet catpure using tcpdump"
NAME=tcpdump
DAEMON=/usr/sbin/$NAME
# tcpdump -n -i eth3 -w /home/roland/test.pcap -C 1 -U -W 10
CAPTURE_DIR="/home/martem/pcap"
IFACE="any"
USER=martem

TCPDUMP=no

PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

[ -r /etc/tcpdump.conf ] && . /etc/tcpdump.conf

DAEMON_ARGS="-n -i $IFACE -C 1 -U -G 3600 -W 30 -Z $USER -w $CAPTURE_DIR/%Y_%m_%d-%H_%M_%S.pcap."

#
# Function that starts the daemon/service
#
do_start()
{


    if [ "$TCPDUMP" = "yes" ]; then
    
        mkdir -p $CAPTURE_DIR
        chmod g+wrx $CAPTURE_DIR


        # Return
        #   0 if daemon has been started
        #   1 if daemon was already running
        #   2 if daemon could not be started
        kill -0 `cat $PIDFILE` && return 1
        start-stop-daemon --start --quiet --pidfile $PIDFILE --background --make-pidfile --background --exec $DAEMON -- \
            $DAEMON_ARGS \
            || return 2
    fi
    # Add code here, if necessary, that waits for the process to be ready
    # to handle requests from services started subsequently which depend
    # on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
    # Return
    #   0 if daemon has been stopped
    #   1 if daemon was already stopped
    #   2 if daemon could not be stopped
    #   other if a failure occurred
    start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
    RETVAL="$?"
    [ "$RETVAL" = 2 ] && return 2
    # Wait for children to finish too if this is a daemon that forks
    # and if the daemon is only ever run from this initscript.
    # If the above conditions are not satisfied then add some other code
    # that waits for the process to drop all resources that could be
    # needed by services started subsequently.  A last resort is to
    # sleep for some time.
    start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
    [ "$?" = 2 ] && return 2
    # Many daemons don't delete their pidfiles when they exit.
    rm -f $PIDFILE
    return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
case "$1" in
  start)
#     [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
    do_start
    return $?
    ;;
  stop)
#     [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
    do_stop
    ;;
  restart|force-reload)
    #
    # If the "reload" option is implemented then remove the
    # 'force-reload' alias
    #
#     log_daemon_msg "Restarting $DESC" "$NAME"
    do_stop
    case "$?" in
      0|1)
        do_start
        return $?
        ;;
      *)
        # Failed to stop
        return 4
        ;;
    esac
    ;;
  *)
    #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
    echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
    exit 3
    ;;
esac